# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

## [3.0.1](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@3.0.0...@billogram/foundation-list-data-provider@3.0.1) (2021-02-04)

### Bug Fixes

* Sync dependency versions ([04decf10](https://github.com/billogram/frontend-foundation/commit/04decf10))



## [3.0.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@2.1.0...@billogram/foundation-list-data-provider@3.0.0) (2021-01-21)

### Features

* Rework (list) data providers ([77bc5508](https://github.com/billogram/frontend-foundation/commit/77bc5508))
* Implement list prosumer ([e53b8141](https://github.com/billogram/frontend-foundation/commit/e53b8141))


### BREAKING CHANGES

* There are major breaking changes to
- foundation-data-provider
- foundation-list-data-provider
- foundation-table



## [2.1.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@2.0.0...@billogram/foundation-list-data-provider@2.1.0) (2021-01-10)

### Bug Fixes

* Use arrow functions for useCallback callbacks ([8ee4239e](https://github.com/billogram/frontend-foundation/commit/8ee4239e))
* Prefer React import ([40e8d46a](https://github.com/billogram/frontend-foundation/commit/40e8d46a))
* Fix react/jsx-no-useless-fragment ([dd348642](https://github.com/billogram/frontend-foundation/commit/dd348642))
* Fix typescript-eslint/no-non-null-assertion ([2c2740e6](https://github.com/billogram/frontend-foundation/commit/2c2740e6))
* Fix linting in foundation-list-data-provider ([5004170f](https://github.com/billogram/frontend-foundation/commit/5004170f))


### Features

* Upgrade React ([978bf30e](https://github.com/billogram/frontend-foundation/commit/978bf30e))



## [2.0.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@1.3.0...@billogram/foundation-list-data-provider@2.0.0) (2020-06-17)

### Features

* Rework the FoundationListDataProviderContext ([83a17cde](https://github.com/billogram/frontend-foundation/commit/83a17cde))
* Add support for cursor ([f07fcdcf](https://github.com/billogram/frontend-foundation/commit/f07fcdcf))


### BREAKING CHANGES

* This completely changes how the
@billogram/foundation-list-data-provider works.
* The fetch data API and metadata have changed.



## [1.3.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@1.2.0...@billogram/foundation-list-data-provider@1.3.0) (2020-06-01)

### Features

* Make it possible to remove an item from a list data provider ([e868b9e6](https://github.com/billogram/frontend-foundation/commit/e868b9e6))



## [1.2.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@1.1.0...@billogram/foundation-list-data-provider@1.2.0) (2020-01-30)

### Features

* Implement useListDataProviderContext ([34ec1391](https://github.com/billogram/frontend-foundation/commit/34ec1391))



## [1.1.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-list-data-provider@1.0.1...@billogram/foundation-list-data-provider@1.1.0) (2020-01-27)

### Features

* Make it possible to update a table row ([f34c2525](https://github.com/billogram/frontend-foundation/commit/f34c2525))



## [1.0.1](https://github.com/billogram/frontend-foundation/compare/dbf5a8709119374207dd2d28f6ffeffac17d5871...@billogram/foundation-list-data-provider@1.0.1) (2020-01-20)

### Bug Fixes

* Export props ([06802c25](https://github.com/billogram/frontend-foundation/commit/06802c25))
* Rename button, error, spinner, and textbox packages ([bf794373](https://github.com/billogram/frontend-foundation/commit/bf794373))
* Prefer interface to type alias ([a9343e5b](https://github.com/billogram/frontend-foundation/commit/a9343e5b))
* Use dependencies instead of peer dependencies ([a1cbff4b](https://github.com/billogram/frontend-foundation/commit/a1cbff4b))
* Use render prop pattern instead of context ([d6206193](https://github.com/billogram/frontend-foundation/commit/d6206193))


### Features

* Add typed contexts ([2c4b571d](https://github.com/billogram/frontend-foundation/commit/2c4b571d))
* Include fetchInitial in render props and context ([c64e6f2d](https://github.com/billogram/frontend-foundation/commit/c64e6f2d))
* Add initial fetch data options ([ba63d985](https://github.com/billogram/frontend-foundation/commit/ba63d985))
* Implement list data provider ([4c348b08](https://github.com/billogram/frontend-foundation/commit/4c348b08))
* Scaffold out @billogram/foundation-list-data-provider ([568692ab](https://github.com/billogram/frontend-foundation/commit/568692ab))


### BREAKING CHANGES

* Force the first release to start from 1.0.0.



## [1.0.0](https://github.com/billogram/frontend-foundation/compare/dbf5a8709119374207dd2d28f6ffeffac17d5871...@billogram/foundation-list-data-provider@1.0.0) (2020-01-20)

### Bug Fixes

* Export props ([06802c25](https://github.com/billogram/frontend-foundation/commit/06802c25))
* Rename button, error, spinner, and textbox packages ([bf794373](https://github.com/billogram/frontend-foundation/commit/bf794373))
* Prefer interface to type alias ([a9343e5b](https://github.com/billogram/frontend-foundation/commit/a9343e5b))
* Use dependencies instead of peer dependencies ([a1cbff4b](https://github.com/billogram/frontend-foundation/commit/a1cbff4b))
* Use render prop pattern instead of context ([d6206193](https://github.com/billogram/frontend-foundation/commit/d6206193))


### Features

* Add typed contexts ([2c4b571d](https://github.com/billogram/frontend-foundation/commit/2c4b571d))
* Include fetchInitial in render props and context ([c64e6f2d](https://github.com/billogram/frontend-foundation/commit/c64e6f2d))
* Add initial fetch data options ([ba63d985](https://github.com/billogram/frontend-foundation/commit/ba63d985))
* Implement list data provider ([4c348b08](https://github.com/billogram/frontend-foundation/commit/4c348b08))
* Scaffold out @billogram/foundation-list-data-provider ([568692ab](https://github.com/billogram/frontend-foundation/commit/568692ab))


### BREAKING CHANGES

* Force the first release to start from 1.0.0.
