import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import React from 'react';
import { makeCancelablePromise } from '@billogram/cancelable-promise';
import listDataFetched from './listDataFetched';
import listDataUpdateItem from './listDataUpdateItem';
import listDataRemoveItem from './listDataRemoveItem';

function noop() {}

export default function createListDataProvider() {
  var FoundationListDataProviderContext = /*#__PURE__*/React.createContext({
    fetchInitial: function () {
      var _fetchInitial = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function fetchInitial() {
        return _fetchInitial.apply(this, arguments);
      }

      return fetchInitial;
    }(),
    fetchMore: function () {
      var _fetchMore = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function fetchMore() {
        return _fetchMore.apply(this, arguments);
      }

      return fetchMore;
    }(),
    fetchSort: function () {
      var _fetchSort = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function fetchSort() {
        return _fetchSort.apply(this, arguments);
      }

      return fetchSort;
    }(),
    removeItem: noop,
    result: {
      state: 'fetching-initial'
    },
    updateItem: noop
  });

  function FoundationListDataProvider(_ref) {
    var children = _ref.children,
        fetchData = _ref.fetchData,
        initialFetchDataOptions = _ref.initialFetchDataOptions,
        _ref$initialLimit = _ref.initialLimit,
        initialLimit = _ref$initialLimit === void 0 ? 10 : _ref$initialLimit,
        _ref$initialSortBy = _ref.initialSortBy,
        initialSortBy = _ref$initialSortBy === void 0 ? 'created_at' : _ref$initialSortBy,
        _ref$initialSortDirec = _ref.initialSortDirection,
        initialSortDirection = _ref$initialSortDirec === void 0 ? 'desc' : _ref$initialSortDirec;
    var cancel = React.useRef(noop);

    var _React$useState = React.useState({
      state: 'fetching-initial'
    }),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        result = _React$useState2[0],
        setResult = _React$useState2[1];

    var fetch = React.useCallback( /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(listOptions, options) {
        var limit, params, _makeCancelablePromis, _makeCancelablePromis2, newRequest, newCancel, token, _token;

        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.prev = 0;
                cancel.current();
                setResult(function (result) {
                  switch (result.state) {
                    case 'error-initial':
                    case 'fetching-initial':
                      {
                        return {
                          state: 'fetching-initial'
                        };
                      }

                    default:
                      {
                        return {
                          data: result.data,
                          meta: result.meta,
                          state: listOptions.mode
                        };
                      }
                  }
                });
                limit = listOptions.limit !== void 0 ? listOptions.limit : initialLimit;
                params = {
                  cursor: listOptions.cursor,
                  limit: limit,
                  offset: listOptions.offset,
                  sortBy: listOptions.sortBy,
                  sortDirection: listOptions.sortDirection
                };
                _makeCancelablePromis = makeCancelablePromise(fetchData(params, options)), _makeCancelablePromis2 = _slicedToArray(_makeCancelablePromis, 2), newRequest = _makeCancelablePromis2[0], newCancel = _makeCancelablePromis2[1];
                cancel.current = newCancel;
                _context4.next = 9;
                return newRequest;

              case 9:
                token = _context4.sent;

                if (!token.isPromiseCanceled) {
                  setResult(listDataFetched(token.value));
                }

                _context4.next = 17;
                break;

              case 13:
                _context4.prev = 13;
                _context4.t0 = _context4["catch"](0);
                _token = _context4.t0;

                if (!_token.isPromiseCanceled) {
                  setResult(function (result) {
                    switch (result.state) {
                      case 'error-initial':
                      case 'fetching-initial':
                        {
                          return {
                            state: 'error-initial'
                          };
                        }

                      default:
                        {
                          return {
                            data: result.data,
                            meta: result.meta,
                            state: listOptions.mode === 'fetching-more' ? 'error-more' : 'error-sort'
                          };
                        }
                    }
                  });
                }

              case 17:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[0, 13]]);
      }));

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }(), [fetchData, initialLimit]);
    var fetchInitial = React.useCallback(function (options) {
      fetch({
        cursor: null,
        mode: 'fetching-initial',
        offset: 0,
        sortBy: initialSortBy,
        sortDirection: initialSortDirection
      }, options);
    }, [fetch, initialSortBy, initialSortDirection]);
    var fetchMore = React.useCallback(function (limit, options) {
      switch (result.state) {
        case 'error-initial':
        case 'fetching-initial':
          {
            break;
          }

        default:
          {
            fetch({
              cursor: result.meta.cursor,
              limit: limit,
              mode: 'fetching-more',
              offset: result.data.items.length,
              sortBy: result.meta.sortBy,
              sortDirection: result.meta.sortDirection
            }, options);
            break;
          }
      }
    }, [fetch, result]);
    var fetchSort = React.useCallback(function (sortBy, options) {
      switch (result.state) {
        case 'error-initial':
        case 'fetching-initial':
          {
            break;
          }

        default:
          {
            var sortDirection = result.meta.sortBy !== sortBy ? result.meta.sortDirection : result.meta.sortDirection === 'asc' ? 'desc' : 'asc';
            fetch({
              cursor: null,
              mode: 'fetching-sort',
              offset: 0,
              sortBy: sortBy,
              sortDirection: sortDirection
            }, options);
            break;
          }
      }
    }, [fetch, result]);
    var updateItem = React.useCallback(function (updatedItem) {
      setResult(listDataUpdateItem(updatedItem));
    }, []);
    var removeItem = React.useCallback(function (removedItem) {
      setResult(listDataRemoveItem(removedItem));
    }, []);
    React.useEffect(function () {
      fetchInitial(initialFetchDataOptions);
      return function () {
        cancel.current();
        cancel.current = noop;
      };
    }, [fetch, fetchInitial, initialFetchDataOptions, initialSortBy, initialSortDirection]);
    var context = React.useMemo(function () {
      return {
        fetchInitial: fetchInitial,
        fetchMore: fetchMore,
        fetchSort: fetchSort,
        removeItem: removeItem,
        result: result,
        updateItem: updateItem
      };
    }, [fetchInitial, fetchMore, fetchSort, removeItem, result, updateItem]);
    return /*#__PURE__*/React.createElement(FoundationListDataProviderContext.Provider, {
      value: context
    }, children);
  }

  function FoundationListDataConsumer(_ref3) {
    var children = _ref3.children;
    return /*#__PURE__*/React.createElement(FoundationListDataProviderContext.Consumer, null, function (context) {
      return children(context);
    });
  }

  function FoundationListDataProsumer(props) {
    var children = props.children,
        providerProps = _objectWithoutProperties(props, ["children"]);

    return /*#__PURE__*/React.createElement(FoundationListDataProvider, providerProps, /*#__PURE__*/React.createElement(FoundationListDataConsumer, null, children));
  }

  function useListDataProvider() {
    return React.useContext(FoundationListDataProviderContext);
  }

  return {
    FoundationListDataConsumer: FoundationListDataConsumer,
    FoundationListDataProsumer: FoundationListDataProsumer,
    FoundationListDataProvider: FoundationListDataProvider,
    useListDataProvider: useListDataProvider
  };
}
//# sourceMappingURL=createListDataProvider.js.map