import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

export default function listDataFetched(fetchResult) {
  return function callback(result) {
    switch (result.state) {
      case 'fetching-initial':
      case 'fetching-sort':
        {
          return {
            data: fetchResult.data,
            meta: {
              cursor: fetchResult.meta.cursor,
              sortBy: fetchResult.meta.orderBy,
              sortDirection: fetchResult.meta.orderDirection
            },
            state: 'success'
          };
        }

      case 'fetching-more':
        {
          return {
            data: _objectSpread(_objectSpread(_objectSpread({}, result.data), fetchResult.data), {}, {
              items: [].concat(_toConsumableArray(result.data.items), _toConsumableArray(fetchResult.data.items))
            }),
            meta: {
              cursor: fetchResult.meta.cursor,
              sortBy: fetchResult.meta.orderBy,
              sortDirection: fetchResult.meta.orderDirection
            },
            state: 'success'
          };
        }

      default:
        {
          throw new Error('This should not happen');
        }
    }
  };
}
//# sourceMappingURL=listDataFetched.js.map